//
// See the file LICENSE for redistribution information.
//
// Copyright (c) 2002-2003
//	Sleepycat Software.  All rights reserved.
//
// $Id: DbXmlFwd.hpp,v 1.56 2004/12/22 17:25:06 gmf Exp $
//

#ifndef __DBXMLFWD_HPP
#define	__DBXMLFWD_HPP

//BEGIN-DBXML-VERSION
/* DO NOT EDIT: automatically built by dist/s_include. */
#define DBXML_VERSION_MAJOR 2
#define DBXML_VERSION_MINOR 0
#define DBXML_VERSION_PATCH 9
#define DBXML_VERSION_STRING "Sleepycat Software: Berkeley DB XML 2.0.9: (December 22, 2004)"
namespace xercesc_2_6 {
class DOMDocument;
class DOMNode;
}
//END-DBXML-VERSION

#include "XmlPortability.hpp"

namespace DbXml
{

class XmlContainer;
class XmlManager;
class XmlDocument;
class XmlException;
class XmlQueryContext;
class XmlUpdateContext;
class XmlResults;
class XmlValue;
class XmlQueryExpression;
class XmlIndexSpecification;
class XmlResolver;
class XmlModify;
class XmlData;
class XmlTransaction;
class XmlInputStream;
class XmlMetaDataIterator;
class XmlStatistics;

//
// Flags:
//
// BDB obviously defines it's own flags:
//
// Common Range 1:
// DB_CREATE            0x00000001
// DB_CXX_NO_EXCEPTIONS 0x00000002 - Not Used
// DB_FORCE             0x00000004 - Not Used
// DB_NOMMAP            0x00000008
// DB_RDONLY            0x00000010
// DB_RECOVER           0x00000020 - Not Used
// DB_THREAD            0x00000040
// DB_TRUNCATE          0x00000080 - Not Used
// DB_TXN_NOSYNC        0x00000100
// DB_TXN_NOT_DURABLE   0x00000200 - Not Used
// DB_USE_ENVIRON       0x00000400 - Not Used
// DB_USE_ENVIRON_ROOT  0x00000800 - Not Used
//
// Common Range 2:
// DB_AUTO_COMMIT       0x01000000 - Not Used
// DB_DIRTY_READ        0x02000000
// DB_NO_AUTO_COMMIT    0x04000000 - Not Used
//
// DbXml also uses a few other random BDB flags:
// DB_XA_CREATE         0x00000002
// DB_RMW               0x10000000
// DB_AGGRESSIVE        0x00000001
// DB_SALVAGE           0x00000040
// DB_EXCL              0x00001000
// DB_TXN_NOWAIT        0x00001000

enum Flags {
	// XmlManager construction flags
	DBXML_ADOPT_DBENV =        0x00000001, ///< adopt the given DbEnv
	DBXML_ALLOW_EXTERNAL_ACCESS = 0x00000002, ///< turn on access to the file system
	DBXML_ALLOW_AUTO_OPEN    = 0x00000004, ///< turn on auto-open of containers referenced in a query

	// Common DbXml flags
	DBXML_ALLOW_VALIDATION =   0x02000000, ///< perform validation on documents if they contain dtd or xsd references
	DBXML_TRANSACTIONAL =      0x04000000, ///< make the container Transactional
	DBXML_CHKSUM =             0x08000000, ///< mapped onto db->set_flags(DB_CHKSUM);
	DBXML_ENCRYPT =            0x10000000, ///< mapped onto db->set_flags(DB_ENCRYPT);
	DBXML_GEN_NAME =           0x20000000, ///< Used by putDocument
	DBXML_LAZY_DOCS =          0x40000000, ///< Used by XmlContainer::getDocument() and XmlQueryExpression::execute()
	DBXML_INDEX_NODES =        0x80000000  ///< Specified at the creation of a container
};

enum LogLevel
{
	LEVEL_NONE =    0x00000000,  ///< No debug levels are enabled.
	LEVEL_DEBUG =   0x00000001,  ///< Program execution tracing messages.
	LEVEL_INFO =    0x00000002,  ///< Informational, just for interest.
	LEVEL_WARNING = 0x00000004,  ///< For warnings, bad things but recoverable.
	LEVEL_ERROR =   0x00000008,  ///< For errors that can't be recovered from.
	LEVEL_ALL =     0xFFFFFFFF   ///< All debug levels are enabled.
};

enum LogCategory
{
	CATEGORY_NONE =       0x00000000,
	CATEGORY_INDEXER =    0x00000001,
	CATEGORY_QUERY =      0x00000002,
	CATEGORY_OPTIMIZER =  0x00000004,
	CATEGORY_DICTIONARY = 0x00000008,
	CATEGORY_CONTAINER =  0x00000010,
	CATEGORY_NODESTORE =  0x00000020,
	CATEGORY_MANAGER =    0x00000040,
	CATEGORY_ALL =        0xFFFFFFFF
};

DBXML_EXPORT const char *dbxml_version(int *majorp, int *minorp, int *patchp);

DBXML_EXPORT void setLogLevel(LogLevel level, bool enabled);

DBXML_EXPORT void setLogCategory(LogCategory category, bool enabled);
}

#endif
