//
// See the file LICENSE for redistribution information.
//
// Copyright (c) 2002-2004
//	Sleepycat Software.  All rights reserved.
//
// $Id: CollectionAndDocOptimizer.hpp,v 1.3 2004/08/23 17:05:48 jsnelson Exp $
//

#ifndef __COLLECTIONANDDOCOPTIMIZER_HPP
#define	__COLLECTIONANDDOCOPTIMIZER_HPP

#include "NodeVisitingOptimizer.hpp"
#include "../ReferenceMinder.hpp"

#include <pathan/XPath2MemoryManager.hpp>

class DynamicContext;

namespace DbXml
{

class CollectionAndDocOptimizer : public NodeVisitingOptimizer
{
public:
  CollectionAndDocOptimizer(ReferenceMinder &minder, DynamicContext *xpc, Optimizer *parent = 0)
    : NodeVisitingOptimizer(parent), inNav_(false),
      xpc_(xpc), minder_(minder)
  {}
  virtual ~CollectionAndDocOptimizer() {}

protected:
  virtual void resetInternal()
  {
    inNav_ = false;
    minder_.resetMinder();
  }
  virtual DataItem *optimizeFunction(DataItemFunction *item);

private:
  bool inNav_;
  DynamicContext *xpc_;
  ReferenceMinder &minder_;
};

}

#endif
