//
// See the file LICENSE for redistribution information.
//
// Copyright (c) 2002-2004
//	Sleepycat Software.  All rights reserved.
//
// $Id: DefaultShell.cpp,v 1.6 2004/09/06 14:01:13 jsnelson Exp $
//

#include "DefaultShell.hpp"
#include "ContainerQueryCommand.hpp"
#include "QueryCommand.hpp"
#include "PrintCommand.hpp"
#include "CommitCommand.hpp"
#include "AbortCommand.hpp"
#include "PreLoadCommand.hpp"
#include "ContextItemQueryCommand.hpp"
#include "OpenContainerCommand.hpp"
#include "ListIndexesCommand.hpp"
#include "AddIndexCommand.hpp"
#include "DeleteIndexCommand.hpp"
#include "SetVariableCommand.hpp"
#include "SetTypedVariableCommand.hpp"
#include "SetNamespaceCommand.hpp"
#include "LazyCommand.hpp"
#include "ReturnTypeCommand.hpp"
#include "RemoveCommand.hpp"
#include "RenameCommand.hpp"
#include "UpdateCommand.hpp"
#include "InsertAfterCommand.hpp"
#include "InsertBeforeCommand.hpp"
#include "AppendCommand.hpp"
#include "ApplyChangesCommand.hpp"
#include "QueryPlanCommand.hpp"
#include "CreateContainerCommand.hpp"
#include "AddDocumentCommand.hpp"
#include "DeleteDocumentCommand.hpp"
#include "SetBaseURICommand.hpp"
#include "IndexLookupCommand.hpp"
#include "StatsLookupCommand.hpp"
#include "StartTransactionCommand.hpp"

#ifndef WIN32
// not include for windows -- it uses internal
// interfaces
#include "DebugCommand.hpp"
#endif

DefaultShell::DefaultShell()
{
	addCommand(new StartTransactionCommand);
	addCommand(new CommitCommand);
	addCommand(new AbortCommand);
	addCommand(new QueryCommand);
	addCommand(new ContainerQueryCommand);
	addCommand(new ContextItemQueryCommand);
	addCommand(new IndexLookupCommand);
	addCommand(new PrintCommand);
	addCommand(new CreateContainerCommand);
	addCommand(new OpenContainerCommand);
	addCommand(new PreLoadCommand);
	addCommand(new AddDocumentCommand);
	addCommand(new DeleteDocumentCommand);
	addCommand(new ListIndexesCommand);
	addCommand(new AddIndexCommand);
	addCommand(new DeleteIndexCommand);
	addCommand(new SetVariableCommand);
	addCommand(new SetTypedVariableCommand);
	addCommand(new SetNamespaceCommand);
	addCommand(new SetBaseURICommand);
	addCommand(new LazyCommand);
	addCommand(new ReturnTypeCommand);
	addCommand(new RemoveCommand);
	addCommand(new RenameCommand);
	addCommand(new UpdateCommand);
	addCommand(new InsertBeforeCommand);
	addCommand(new InsertAfterCommand);
	addCommand(new AppendCommand);
	addCommand(new ApplyChangesCommand);
	addCommand(new QueryPlanCommand);
	addCommand(new StatsLookupCommand);
#ifndef WIN32
	addCommand(new DebugCommand);
#endif
}
