//
// See the file LICENSE for redistribution information.
//
// Copyright (c) 2002-2004
//	Sleepycat Software.  All rights reserved.
//
// $Id: QuitCommand.cpp,v 1.2 2004/08/19 16:52:27 gareth Exp $
//

#include "QuitCommand.hpp"

using namespace DbXml;
using namespace std;

string QuitCommand::getCommandName() const
{
  return "quit";
}

string QuitCommand::getBriefHelp() const
{
  return "Exit the program";
}

string QuitCommand::getMoreHelp() const
{
  return "";
}

void QuitCommand::execute(Args &args, Environment &env)
{
  if(args.size() != 1) {
    throw CommandException("Wrong number of arguments");
  }

  env.quit() = true;
}
