//
// See the file LICENSE for redistribution information.
//
// Copyright (c) 2002-2004
//	Sleepycat Software.  All rights reserved.
//
// $Id: SetVariableCommand.cpp,v 1.2 2004/08/19 16:52:27 gareth Exp $
//

#include "SetVariableCommand.hpp"

using namespace DbXml;
using namespace std;

string SetVariableCommand::getCommandName() const
{
  return "varset";
}

string SetVariableCommand::getBriefHelp() const
{
  return "Set a variable in the default context";
}

string SetVariableCommand::getMoreHelp() const
{
  return
    string("Takes arguments of the name of the variable to set, and the value\n") +
    string("to set it to. This command uses the\n") +
    string("XmlQueryContext::setVariableValue() method.");
}

void SetVariableCommand::execute(Args &args, Environment &env)
{
  if(args.size() != 3) {
    throw CommandException("Wrong number of arguments");
  }

  if(env.verbose()) cout << "Setting $" << args[1] << " = " << args[2] << endl;
  env.context().setVariableValue(args[1], args[2]);
}

