//
// See the file LICENSE for redistribution information.
//
// Copyright (c) 2002-2004
//	Sleepycat Software.  All rights reserved.
//
// $Id: Shell.hpp,v 1.2 2004/08/19 16:52:27 gareth Exp $
//

#ifndef __SHELL_HPP
#define	__SHELL_HPP

#include "dbxml/DbXml.hpp"
#include <vector>
#include <string>

#include "InputParser.hpp"

class ShellCommand;
class Environment;

class Shell
{
public:
  Shell();
	virtual ~Shell();

  /// Returns false if there were errors
  virtual bool mainLoop(std::istream &in, Environment &env) const;

  void addCommand(ShellCommand *command);

private:
  Shell(const Shell &);
  Shell &operator=(const Shell &);

  std::vector<ShellCommand*> commands_;
};

#endif
